# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from .image_generation import ImageGeneration


class ImageGenerationResponse(pydantic_v1.BaseModel):
    """
    Response to an ImageGenerationRequest.
    """

    images: typing.List[ImageGeneration] = pydantic_v1.Field()
    """
    List of ImageGeneration(s) generated by the request.
    """

    prediction_time_ms: float = pydantic_v1.Field()
    """
    Total runtime of the image generation(s).
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
