# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from .completion_choice import CompletionChoice
from .usage_stats import UsageStats


class CompletionResponse(pydantic_v1.BaseModel):
    """
    Represents a completion response from the API.
    Note: both the streamed and non-streamed response objects
    share the same shape (unlike the chat endpoint).
    """

    choices: typing.List[CompletionChoice]
    created: int = pydantic_v1.Field()
    """
    The Unix timestamp (in seconds) of when the completion was created.
    """

    id: str
    model: str
    object: typing.Optional[typing.Any] = None
    system_fingerprint: str
    usage: typing.Optional[UsageStats] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
