# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1


class LogProbs(pydantic_v1.BaseModel):
    """
    The tokens and their [log probabilities](https://en.wikipedia.org/wiki/Log_probability).
    """

    text_offset: typing.Optional[typing.List[int]] = None
    token_logprobs: typing.Optional[typing.List[typing.Optional[float]]] = None
    tokens: typing.Optional[typing.List[str]] = None
    top_logprobs: typing.Optional[typing.List[typing.Optional[typing.Dict[str, typing.Optional[float]]]]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
